//#include <dos.h>
#include "allhereg.h"

void initgraphics()      // set mode 13
{

 setmode(0x13);

}

//-----------------------------------------

void exitgraphics()       //set mode 3
{

 setmode(0x03);

}

//-----------------------------------------

void setmode(unsigned char mode)     //set mode (mode)
{

 asm {

  mov   ah, 0
  mov	al, mode
  int	0x10

 }

}

//------------------------------------------

void putpixel(int x, int y, unsigned char color)   // plot (x,y,colour)

{
asm {

 // ;ax is colour
 // ;bx is x
 // ;cx is y
	  mov 	al,	color
	  mov   bx,	x
	  mov	cx,	y
	  xchg  ch,     cl          // ; y * 256
	  add   bx,     cx          // ; x + ( 256 * y )
	  shr   cx,     2           // ; ( 256 * y ) / 4 = 64 * y
	  add   bx,     cx          // ; ( x + 256y ) + ( y * 64 ) = x + 320y
	  mov   di,     bx          // ; Thanks Phil.
	  mov   cx,     0a000h      // ; this could be done once...
	  mov   es,     cx
	  mov   es:[di],al

 }
}


//------------------------------------------

void line(int x1, int y1, int x2, int y2, int colour, char far *screen)
{



 int y_unit,x_unit;
 int offset=y1*320+x1;
 int ydiff=y2-y1;

 if (ydiff<0)
  {
  ydiff=-ydiff;
  y_unit =-320;
  }
 else y_unit =320;

 int xdiff=x2-x1;
 if (xdiff<0)
  {
  xdiff=-xdiff;
  x_unit=-1;
  }
 else x_unit=1;

 int error_term=0;
 if (xdiff>ydiff)
  {
  int length=xdiff+1;
  for (int i=0; i<length; i++)
  {
   screen[offset]=colour;
   offset+=x_unit;
   error_term+=ydiff;
   if (error_term>xdiff)
    {
    error_term-=xdiff;
    offset+=y_unit;
    }
   }
  }
  else
   {
   int length=ydiff+1;
   for (int i=0; i<length; i++)
    {
    screen[offset]=colour;
    offset+=y_unit;
    error_term+=xdiff;
    if (error_term>0)
     {
     error_term-=ydiff;
     offset+=x_unit;
     }
    }
   }
  }
  //---------------------------------------

  void cls(char far *screen)
  {
  //char far *screen = (char*)MK_FP(0XA000,0X000);
  //for (unsigned int i=0; i<64000; i++) screen[i]=0;
  asm {
  les di,screen
  mov cx,32000
  mov ax,0
  rep stosw
  }
  }


  //---------------------------------------

  void mouseinit()
  {
  asm {
  mov ax,0
  int 0x33
  }
  }

  //--------------------------------------

  void relpos(char far *x, char far *y)
  {
  asm {
  mov ax,0x000b
  int 0x33
  les bx,x
  mov [es:bx],cx
  les bx,y
  mov [es:bx],dx
  }
  }

  //-------------------------------------

  int mbutton()
  {
  asm {
  mov ax,0x3
  int 0x33
  mov ax,bx
  }
  return(0);
  }

  //-----------------------------------------

  int eschit()
  {
  asm {
	in 	al,	64h
	and 	al,	1
	mov 	ax,	0
	jnz	kil
	in	al, 	60h
	cmp	al,	27
	jnz	kil
	mov	ax,	0
  }
kil:
 asm {
	ret
   }
   return(0);
  }